#ifndef _mydefs_h_
#define _mydefs_h_


//some macros
#define Tog_Bit(Port, Bit)	Port ^= _BV(Bit)	//Toggle Bit
#define Set_Bit(Port, Bit)	Port |= _BV(Bit)	//set Bit
#define Clr_Bit(Port, Bit)	Port &= ~_BV(Bit)	//clear Bit

// set 2 output , Set2Output(DDRC, PC2);
#define Set2Output(DataDirection, Pin)	Set_Bit(DataDirection, Pin)
#define Set2Hiz(DataDirection, Pin) 	Clr_Bit(DataDirection, Pin)

// If Port is defined as Input   write 1 to Port means enable internal Pullup
#define enable_pullup(Port, Pin)		Set_Bit(Port, Pin)  //e.g. enable_pullup(portb, pb2);
#define disable_pullup(port, Pin)		Clr_Bit(Port, Pin)


struct bits {
  uint8_t b0:1;
  uint8_t b1:1;
  uint8_t b2:1;
  uint8_t b3:1;
  uint8_t b4:1;
  uint8_t b5:1;
  uint8_t b6:1;
  uint8_t b7:1;
} __attribute__((__packed__));

#define SBIT(port,pin) ((*(volatile struct bits*)&port).b##pin)
// z.B. #define	LED		SBIT( PORTA, 4 )
// im Main dann LED = 1;


#endif
